<?php

namespace Tests\Feature;

use App\Models\Product;
use App\Models\User;
use App\Repositories\Product\ProductRepositoryInterface;
use App\Repositories\ProductCommentFile\ProductCommentFileRepositoryInterface;
use Illuminate\Foundation\Testing\DatabaseTransactions;
use Illuminate\Foundation\Testing\RefreshDatabase;
use Illuminate\Foundation\Testing\WithFaker;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Tests\TestCase;

class AddCommentTest extends TestCase
{
    use DatabaseTransactions;

    private $mockUser;

    protected function setUp(): void
    {
        parent::setUp(); // TODO: Change the autogenerated stub
        $this->withoutMiddleware();
        $this->mockUser = new User();
        $this->mockUser->setAttribute('id', 1);
        Auth::shouldReceive('user')->andReturn($this->mockUser);

    }

    /**
     * test validation
     *
     * @return void
     */
    public function test_input_validation()
    {
        $response = $this->post('/api/v1/comments/add', [], ['Accept' => 'application/json']);
        $response->assertStatus(422);
        $response = $this->post('/api/v1/comments/add', ['product_name' => 'A'], ['Accept' => 'application/json']);
        $response->assertStatus(422);
        $response = $this->post('/api/v1/comments/add', ['message' => 'test message'], ['Accept' => 'application/json']);
        $response->assertStatus(422);


    }

    /**
     * A basic feature test example.
     *
     * @return void
     */
    public function test_add_comment()
    {
        $countBefore = DB::table('comments')->count();
        $this->mock_product_repository();
        $this->mock_product_comment_file_repository();
        $response = $this->post('/api/v1/comments/add',
            ['product_name' => 'A', 'message' => 'test message']);

        $response->assertStatus(200);
        $countAfter = DB::table('comments')->count();

        $this->assertEquals($countBefore + 1, $countAfter,);
    }

    /**
     * @return void
     */
    public function test_user_comment_Limit()
    {
        $this->mock_product_repository(2);
        $this->mock_product_comment_file_repository();
        $response = $this->post('/api/v1/comments/add',
            ['product_name' => 'A', 'message' => 'test message']);
        $response->assertStatus(400);
    }


    private function mock_product_repository($comment_count = 1)
    {
        $product = new Product();
        $product->setAttribute('id', 1);
        $product->setAttribute('name', 'test');
        $product->setAttribute('comments_count', $comment_count);
        $mock = \Mockery::mock(ProductRepositoryInterface::class);
        $mock->shouldReceive('findByName')->andReturn($product);
        $mock->shouldReceive('userCommentsCount')->andReturn($product);
        $mock->shouldReceive('commentsCount')->andReturn(2);
        $this->app->instance(ProductRepositoryInterface::class, $mock);
    }

    private function mock_product_comment_file_repository()
    {
        $mock = \Mockery::mock(ProductCommentFileRepositoryInterface::class);
        $mock->shouldReceive('create')->andReturn();
        $mock->shouldReceive('addNewLine')->andReturn();
        $mock->shouldReceive('update')->andReturn();
        $this->app->instance(ProductCommentFileRepositoryInterface::class, $mock);

    }
}
